/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2016/17      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : lecture 3
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description: race conditions
///
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <vector>
#include <thread>
#include <cstdlib>

const unsigned int n = 8192;

std::vector<int> A( n*n, 1);
std::vector<int> b( n, 1);
std::vector<int> c( n, 0);

////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////
void
compute_row( unsigned int row, unsigned int n)
{
  for( unsigned int i = 0; i < n; ++i) {
    c[row] += A[row*n + i] * b[i];
  }
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// program entry point
////////////////////////////////////////////////////////////////////////////////////////////////////
int
main( int /*argc*/, char** /*argv*/ ) {

  std::vector< std::thread > threads;

  for( unsigned int i = 0; i < n; ++i) {
    threads.push_back( std::thread( compute_row, i, n));
  }

  for( unsigned int i = 0; i < n; ++i) {
    threads[i].join();
  }

  for( unsigned int i = 0; i < n; ++i) {
    if( n != c[i]) {
      std::cout << "Error in row = " << i  << " :: value = " << c[i] << std::endl;
    }
  }

  return EXIT_SUCCESS;
}
